# -*- coding: utf-8 -*-
from __future__ import absolute_import, print_function
import json


def policies(session, scope='Local'):
    client = session.client('iam')

    policies = client.list_policies(Scope=scope)
    for policy in policies.get('Policies', []):
        yield policy


def export_policy(session, policy_arn, filename):
    policy_document = download_policy(session, policy_arn)

    with open(filename, 'w') as outfile:
        outfile.write(json.dumps(policy_document, indent=4))


def download_policy(session, policy_arn):
    client = session.client('iam')

    policy = client.get_policy(PolicyArn=policy_arn).get('Policy')
    version = policy.get('DefaultVersionId')

    policy_data = client.get_policy_version(PolicyArn=policy_arn,
                                            VersionId=version)

    policy_version = policy_data.get('PolicyVersion')

    return policy_version.get('Document')
